/***************************************************************************
 *   Copyright (C) 2004 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CAMERA_H__
#define CAMERA_H__ 
 
#include "includes.h"

class CoglCamera3D {
	// class to control the OpenGL camera
	
	public:
		CoglCamera3D();
		CoglCamera3D(float pos_x, float pos_y, float pos_z);
		~CoglCamera3D();
		void left();
		void right();
		void up();
		void down();
		void forward();
		void backward();
		void setCamPos();
		void updateMouseData(double dMoveX, double dMoveY, double dRadius, int state);
		void setCameraMode(int mode);
		void setViewPoint(float x, float y, float z);

	private:
		CVector3D vRotationVector;
		CVector3D vKameraViewPoint;
		int mode;
		int oben;

		void calcPosFreeCam(double dMoveX, double dMoveY, double dRadius, int state);
		void calcPosCenterCam(double dMoveX, double dMoveY, double dRadius, int state);
};

#endif // CAMERA_H__
