/***************************************************************************
 *   Copyright (C) 2005 Chemnitz University of Technology                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "moments.h"

CMoments::CMoments()
{
}


CMoments::~CMoments()
{
}

int CMoments::Moment(int i, int j, int k, CVoxelObject3D *v) {

    int moment = 0;

    for (int w = 0; w < v->m_ScopeX; w++) {
        for (int h = 0; h < v->m_ScopeY; h++) {
            for (int d = 0; d < v->m_ScopeZ; d++) {

                // check if voxel(w,h,d) is set
                if (v->m_CubeArray(w,h,d).flag == CT_EMPTY) continue;

                moment += pow((float)w+1, i) * pow((float)h+1, j) * pow((float)d+1, k);
            }
        }
    }

    return moment;
}

int CMoments::CentralMoment(int i, int j, int k, CVoxelObject3D *v) {

    // check if centroid is given
    if (v->m_CentroidX < 0 || v->m_CentroidX >= v->m_ScopeX || v->m_CentroidY < 0 || v->m_CentroidY >= v->m_ScopeY || v->m_CentroidZ < 0 || v->m_CentroidZ >= v->m_ScopeZ) v->RecalculateCentroid();

    int moment = 0;

    for (int w = 0; w < v->m_ScopeX; w++) {
        for (int h = 0; h < v->m_ScopeY; h++) {
            for (int d = 0; d < v->m_ScopeZ; d++) {

                // check if voxel(w,h,d) is set
                if (v->m_CubeArray(w,h,d).flag == CT_EMPTY) continue;

                moment += pow((float)w+1 - v->m_CentroidX, i) * pow((float)h+1 - v->m_CentroidY, j) * pow((float)d+1 - v->m_CentroidZ, k);
            }
        }
    }

    return moment;
}


