/***************************************************************************
 *   Copyright (C) 2004 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CMOUSE_H
#define CMOUSE_H

#include "includes.h"

/**
@author Holger Gerth
*/
class CMouse{

    public:

        CMouse();
        ~CMouse();

        void setLastState(const int& theValue);
        int getLastState() const;
        void setCurX(const int& theValue);
        int getCurX() const;
        void setMoveY(double theValue);
        double getMoveY() const;
        void setMoveX(double theValue);
        double getMoveX() const;
        void setCurY(const int& theValue);
        int getCurY() const;
        void setRadius(double theValue);
        double getRadius() const;
        void setOldY(const int& theValue);
        int getOldY() const;
        void setOldX(const int& theValue);
        int getOldX() const;

    private:

        double dMoveX, dMoveY, dRadius;
        int dOldX, dOldY, dCurX, dCurY, LastState;

};

#endif // CMOUSE_H

