/***************************************************************************
 *   Copyright (C) 2006 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SWLOBJECT_H
#define SWLOBJECT_H
#include <fstream>
#include <cstdlib>
#include <iostream>
#include "includes.h"
#include "polygon.h"
#include "vertex3d.h"

using namespace std;

/**
        @short File Parser for SMF files
	@author Holger Gerth <holger.gerth@informatik.tu-chemnitz.de>
*/
class CsmfObject{
public:
    CsmfObject();
    CsmfObject( const char* filename );

    ~CsmfObject();

    bool loadObjectFile( const char* filename );
    bool DoRecalculateBoundingbox();

    unsigned int getFaceCount() const;
    unsigned int getVertexCount() const;
    CVertex3D getVertexAtPos( int pos ) const;
    CPolygon getFaceAtPos( int pos ) const;
    CVertex3D getVBB_lowerCorner() const;
    CVertex3D getVBB_upperCorner() const;
    void draw();


private:
    vector<CVertex3D>           vVertices;
    vector<CPolygon>            vFaces;
    unsigned int                iVertexCount;
    unsigned int                iFaceCount;

    CVertex3D                   vBB_upperCorner;
    CVertex3D                   vBB_lowerCorner;

    void addVertex( float x, float y, float z );
    void addFace( int a, int b, int c );
    CVector3D calcNormal( CVector3D a, CVector3D b );
};

#endif
