/***************************************************************************
 *   Copyright (C) 2007 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef STRUCTURES_H__
#define STRUCTURES_H__

#include <iostream>
#include <cstdlib>
#include <vector>

using namespace std;

// type of border point
enum borderPointType {
    BP_NONE,            // no border point
    BP_BOTTOM,          // border point at z-1
    BP_TOP,             // border point at z+1
    BP_EAST,            // border point at y+1
    BP_WEST,            // border point at y-1
    BP_SOUTH,           // border point at x+1
    BP_NORTH            // border point at x-1
};

// type of connectivity
enum connectivity {
    N6,
    N18,
    N26
};

// type of morphological operation
enum morphType {
    DILATION,
    EROSION,
    OPENING,
    CLOSING
};

typedef struct struct_DefinedPoint {
    vector<int>         coordinate;     // coordinates
    bool                isDeleted;
} definedPoint;

typedef struct struct_coordinate_value {
    vector<int>         coordinates;    // coordinates
    unsigned int        index;          // defined data index
    double              value;          // the defined value
} coordinate_value;


typedef struct structCoordValue {
    short int                         coord;
    vector<struct structCoordValue>   subCoords;
} coordValue;

typedef struct structAdjacency {
//     short int                           position;
    vector<short int>                   adjVoxels;
} adjacency;

#endif //STRUCTURES_H__
