// Surface.cpp: Implementierung der Klasse CSurface.
//
//////////////////////////////////////////////////////////////////////

#include "surface.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CSurface::CSurface()
{

    cName               = NULL;
    cParent             = NULL;
    fDiffuse            = 0;
    fSpecular           = 0;
    fAmbient            = 0;
    fLuminosity	        = 0;
    fReflection	        = 0;
    fTransparency	= 0;
    fTranslucency	= 0;
    fGlossiness	        = 0;
    ccColor             = CColor4f();

    cName               = new char[50*sizeof(char)];        // name of the surface
    cParent             = new char[50*sizeof(char)];        // name of the parent surface

}

CSurface::~CSurface()
{

}


char* CSurface::getName() const
{
  return cName;
}


void CSurface::setName(char* theValue)
{
  cName = theValue;
}


char* CSurface::getParentName() const
{
  return cParent;
}


void CSurface::setParentName(char* theValue)
{
  cParent = theValue;
}


CColor4f CSurface::getColor() const
{
  return ccColor;
}


void CSurface::setColor(const CColor4f& theValue)
{
  ccColor.setRed( theValue.getRed() );
  ccColor.setGreen( theValue.getGreen() );
  ccColor.setBlue( theValue.getBlue() );
}

void CSurface::setColor( float r, float g, float b )
{
  ccColor.setRed( r );
  ccColor.setGreen( g );
  ccColor.setBlue( b );
}


float CSurface::getAmbientMaterial() const
{
  return fAmbient;
}


void CSurface::setAmbientMaterial(float theValue)
{
  fAmbient = theValue;
}


float CSurface::getDiffuseMaterial() const
{
  return fDiffuse;
}


void CSurface::setDiffuseMaterial(float theValue)
{
  fDiffuse = theValue;
}


int CSurface::getGlossiness() const
{
  return fGlossiness;
}


void CSurface::setGlossiness(const int& theValue)
{
  fGlossiness = theValue;
}


float CSurface::getReflection() const
{
  return fReflection;
}


void CSurface::setReflection(float theValue)
{
  fReflection = theValue;
}


float CSurface::getSpecularMaterial() const
{
  return fSpecular;
}


void CSurface::setSpecularMaterial(float theValue)
{
  fSpecular = theValue;
}


float CSurface::getTranslucency() const
{
  return fTranslucency;
}


void CSurface::setTranslucency(float theValue)
{
  fTranslucency = theValue;
}


float CSurface::getTransparency() const
{
  return fTransparency;
}


void CSurface::setTransparency(float theValue)
{
  fTransparency = theValue;
}


float CSurface::getLuminosity() const
{
  return fLuminosity;
}


void CSurface::setLuminosity(float theValue)
{
  fLuminosity = theValue;
}
