// Surface.h: Schnittstelle fr die Klasse CSurface.
//
//////////////////////////////////////////////////////////////////////

#if !defined(SURFACE_H_INCLUDED_)
#define SURFACE_H_INCLUDED_

#include "includes.h"
#include "color4f.h"

class CSurface  
{
    public:

        /////////////////////////// member variables ///////////////////////////////////////

        /////////////////////////// member functions ///////////////////////////////////////

        CSurface();
        virtual ~CSurface();

        void setName(char* theValue);
        char* getName() const;
        void setParentName(char* theValue);
        char* getParentName() const;
        void setColor(const CColor4f& theValue);
        void setColor( float r, float g, float b );
        CColor4f getColor() const;
        void setAmbientMaterial(float theValue);
        float getAmbientMaterial() const;
        void setDiffuseMaterial(float theValue);
        float getDiffuseMaterial() const;
        void setGlossiness(const int& theValue);
        int getGlossiness() const;
        void setReflection(float theValue);
        float getReflection() const;
        void setSpecularMaterial(float theValue);
        float getSpecularMaterial() const;
        void setTranslucency(float theValue);
        float getTranslucency() const;
        void setTransparency(float theValue);
        float getTransparency() const;
        void setLuminosity(float theValue);
        float getLuminosity() const;	

    private:

        /////////////////////////// member variables ///////////////////////////////////////

        char*		cName;
        char*		cParent;
        CColor4f	ccColor;
        float		fDiffuse;
        float		fSpecular;
        float		fAmbient;
        float		fLuminosity;
        float		fReflection;
        float		fTransparency;
        float		fTranslucency;
        int		fGlossiness;

};

#endif // !defined(SURFACE_H_INCLUDED_)
